<template>
  <q-page padding>
    <div class="text-h5 q-mb-md">Listado de Eventos</div>

    <q-card class="q-mt-sm">
      <q-list bordered>
        <q-expansion-item icon="filter_alt" label="Filtros Avanzados">
          <template v-slot:header>
            <q-item-section> Filtros Avanzados </q-item-section>
            <q-item-section side v-if="EventoListadoStore.filtroActivado">
              <q-badge color="blue"> Existe un filtro aplicado </q-badge>
            </q-item-section>
          </template>
          <q-card>
            <q-card-section>
              <div class="q-col-gutter-md row">
                <q-input
                  class="col col-sm-2 col-xs-12"
                  v-model="EventoListadoStore.filtros.query"
                  label="Buscar"
                  stack-label
                  dense
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="EventoListadoStore.filtros.tipo"
                  :options="eventosListadoSelect.tipo"
                  label="Tipo Evento"
                  dense
                  multiple
                  use-chips
                  emit-value
                  stack-label
                  map-options
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="EventoListadoStore.filtros.estado"
                  :options="eventosListadoSelect.estado"
                  label="Estado"
                  dense
                  multiple
                  use-chips
                  emit-value
                  stack-label
                  map-options
                />

                <q-select
                  class="col col-sm-2 col-xs-12"
                  v-model="EventoListadoStore.filtros.area"
                  :options="eventosListadoSelect.area"
                  label="Area"
                  dense
                  multiple
                  use-chips
                  emit-value
                  stack-label
                  map-options
                />
              </div>
            </q-card-section>
            <q-card-actions align="right">
              <q-btn flat color="primary" @click="onFiltrar">Filtrar</q-btn>
              <q-btn flat color="red" @click="onResetFiltros">
                Borrar Filtro
              </q-btn>
            </q-card-actions>
          </q-card>
        </q-expansion-item>
      </q-list>
    </q-card>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="EventoListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:body-cell-datos="props">
          <q-td :props="props">
            <q-item>
              <q-item-section top avatar>
                <q-avatar>
                  <img
                    :src="
                      '/img/areas/' +
                      props.row.area_codigo.toLowerCase() +
                      '.svg'
                    "
                    width="50"
                    height="50"
                  />
                </q-avatar>
              </q-item-section>

              <q-item-section>
                <q-item-label>{{ props.row.evento }}</q-item-label>
                <q-item-label caption lines="2">
                  <span>Area :</span> {{ props.row.area }}
                </q-item-label>
                <q-item-label caption lines="3">
                  <span>Org. :</span> {{ props.row.organismo.full }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-detalle="props">
          <q-td :props="props">
            <q-item class="max-w">
              <q-item-section>
                <q-item-label caption lines="1">
                  <span>Fecha Inicio :</span>
                  {{ $filters.DateTime(props.row.fecha_evento) }}
                </q-item-label>
                <q-item-label caption lines="2">
                  <span>Cierre Inscripcion. :</span>
                  {{ $filters.Date(props.row.cierre_inscripcion) }} 23:59
                </q-item-label>
                <q-item-label caption lines="3">
                  <span>Inscriptos :</span> {{ props.row.inscriptos }}
                </q-item-label>
                <q-item-label caption lines="4">
                  <span>Responsable :</span> {{ props.row.responsable }}
                </q-item-label>
                <q-item-label caption lines="4">
                  <span>Costo : </span> ${{ props.row.costo }}
                </q-item-label>
              </q-item-section>
            </q-item>
          </q-td>
        </template>

        <template v-slot:body-cell-estado="props">
          <q-td :props="props">
            <q-chip square dark :color="colorEstados[props.row.estado_codigo]">
              {{ props.row.estado }}
            </q-chip>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              color="green"
              size="sm"
              :to="'/eventos/administracion/detalle/' + props.row.uuid"
            >
              Detalle
            </q-btn>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import {
  useEventosListadoStore,
  eventosListadoSelect,
} from 'src/stores/eventos/listado';
import Loading from 'src/components/Loading.vue';

interface colorEstadosType {
  PRESELECCION: string;
  INSCR_ABIERTA: string;
  INSCR_CERRADA: string;
  FINALIZADO: string;
  ANULADO: string;
}

const colorEstados = <colorEstadosType>{
  PRESELECCION: 'orange',
  INSCR_ABIERTA: 'green',
  INSCR_CERRADA: 'blue',
  FINALIZADO: 'purple',
  ANULADO: 'red',
};

// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'datos', label: 'Datos', field: 'datos', align: 'left' },
  {
    name: 'detalle',
    label: 'Detalle',
    field: 'detalle',
    align: 'right',
  },
  { name: 'estado', label: 'estado', field: 'estado', align: 'center' },
  { name: 'opciones', label: 'opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoPage',
  setup() {
    const loading = ref(true);
    const EventoListadoStore = useEventosListadoStore();

    const filtros = reactive({
      tipo: 'miseventos',
      area: null,
      estado: 'activos',
    });

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      EventoListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      EventoListadoStore.filtroActivado = true;
      EventoListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/eventos/eventos', {
          params: EventoListadoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          EventoListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      EventoListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      EventoListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      eventosListadoSelect,
      colorEstados,
      filtros,
      loading,
    };
  },
});
</script>
